# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetApprovalWorkflowResult',
    'AwaitableGetApprovalWorkflowResult',
    'get_approval_workflow',
    'get_approval_workflow_output',
]

@pulumi.output_type
class GetApprovalWorkflowResult:
    """
    A collection of values returned by getApprovalWorkflow.
    """
    def __init__(__self__, approval_mode=None, approval_steps=None, approval_workflows=None, description=None, id=None, ids=None, name=None):
        if approval_mode and not isinstance(approval_mode, str):
            raise TypeError("Expected argument 'approval_mode' to be a str")
        pulumi.set(__self__, "approval_mode", approval_mode)
        if approval_steps and not isinstance(approval_steps, list):
            raise TypeError("Expected argument 'approval_steps' to be a list")
        pulumi.set(__self__, "approval_steps", approval_steps)
        if approval_workflows and not isinstance(approval_workflows, list):
            raise TypeError("Expected argument 'approval_workflows' to be a list")
        pulumi.set(__self__, "approval_workflows", approval_workflows)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="approvalMode")
    def approval_mode(self) -> Optional[builtins.str]:
        """
        Approval mode of the ApprovalWorkflow
        """
        return pulumi.get(self, "approval_mode")

    @property
    @pulumi.getter(name="approvalSteps")
    def approval_steps(self) -> Optional[Sequence['outputs.GetApprovalWorkflowApprovalStepResult']]:
        """
        The approval steps of this approval workflow
        """
        return pulumi.get(self, "approval_steps")

    @property
    @pulumi.getter(name="approvalWorkflows")
    def approval_workflows(self) -> Sequence['outputs.GetApprovalWorkflowApprovalWorkflowResult']:
        """
        A list where each element has the following attributes:
        """
        return pulumi.get(self, "approval_workflows")

    @property
    @pulumi.getter
    def description(self) -> Optional[builtins.str]:
        """
        Optional description of the ApprovalWorkflow.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        Unique identifier of the ApprovalWorkflow.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ids(self) -> Sequence[builtins.str]:
        """
        a list of strings of ids of data sources that match the given arguments.
        """
        return pulumi.get(self, "ids")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        Unique human-readable name of the ApprovalWorkflow.
        """
        return pulumi.get(self, "name")


class AwaitableGetApprovalWorkflowResult(GetApprovalWorkflowResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetApprovalWorkflowResult(
            approval_mode=self.approval_mode,
            approval_steps=self.approval_steps,
            approval_workflows=self.approval_workflows,
            description=self.description,
            id=self.id,
            ids=self.ids,
            name=self.name)


def get_approval_workflow(approval_mode: Optional[builtins.str] = None,
                          approval_steps: Optional[Sequence[Union['GetApprovalWorkflowApprovalStepArgs', 'GetApprovalWorkflowApprovalStepArgsDict']]] = None,
                          description: Optional[builtins.str] = None,
                          id: Optional[builtins.str] = None,
                          name: Optional[builtins.str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetApprovalWorkflowResult:
    """
    ApprovalWorkflows are the mechanism by which requests for access can be viewed by authorized
     approvers and be approved or denied.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdm as sdm

    manual_approval_workflow_query = sdm.get_approval_workflow(approval_mode="manual",
        name="approval workflow manual")
    auto_grant_approval_workflow_query = sdm.get_approval_workflow(approval_mode="automatic",
        name="approval workflow auto")
    ```


    :param builtins.str approval_mode: Approval mode of the ApprovalWorkflow
    :param Sequence[Union['GetApprovalWorkflowApprovalStepArgs', 'GetApprovalWorkflowApprovalStepArgsDict']] approval_steps: The approval steps of this approval workflow
    :param builtins.str description: Optional description of the ApprovalWorkflow.
    :param builtins.str id: Unique identifier of the ApprovalWorkflow.
    :param builtins.str name: Unique human-readable name of the ApprovalWorkflow.
    """
    __args__ = dict()
    __args__['approvalMode'] = approval_mode
    __args__['approvalSteps'] = approval_steps
    __args__['description'] = description
    __args__['id'] = id
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdm:index/getApprovalWorkflow:getApprovalWorkflow', __args__, opts=opts, typ=GetApprovalWorkflowResult).value

    return AwaitableGetApprovalWorkflowResult(
        approval_mode=pulumi.get(__ret__, 'approval_mode'),
        approval_steps=pulumi.get(__ret__, 'approval_steps'),
        approval_workflows=pulumi.get(__ret__, 'approval_workflows'),
        description=pulumi.get(__ret__, 'description'),
        id=pulumi.get(__ret__, 'id'),
        ids=pulumi.get(__ret__, 'ids'),
        name=pulumi.get(__ret__, 'name'))
def get_approval_workflow_output(approval_mode: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                 approval_steps: Optional[pulumi.Input[Optional[Sequence[Union['GetApprovalWorkflowApprovalStepArgs', 'GetApprovalWorkflowApprovalStepArgsDict']]]]] = None,
                                 description: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                 id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                 name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetApprovalWorkflowResult]:
    """
    ApprovalWorkflows are the mechanism by which requests for access can be viewed by authorized
     approvers and be approved or denied.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdm as sdm

    manual_approval_workflow_query = sdm.get_approval_workflow(approval_mode="manual",
        name="approval workflow manual")
    auto_grant_approval_workflow_query = sdm.get_approval_workflow(approval_mode="automatic",
        name="approval workflow auto")
    ```


    :param builtins.str approval_mode: Approval mode of the ApprovalWorkflow
    :param Sequence[Union['GetApprovalWorkflowApprovalStepArgs', 'GetApprovalWorkflowApprovalStepArgsDict']] approval_steps: The approval steps of this approval workflow
    :param builtins.str description: Optional description of the ApprovalWorkflow.
    :param builtins.str id: Unique identifier of the ApprovalWorkflow.
    :param builtins.str name: Unique human-readable name of the ApprovalWorkflow.
    """
    __args__ = dict()
    __args__['approvalMode'] = approval_mode
    __args__['approvalSteps'] = approval_steps
    __args__['description'] = description
    __args__['id'] = id
    __args__['name'] = name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdm:index/getApprovalWorkflow:getApprovalWorkflow', __args__, opts=opts, typ=GetApprovalWorkflowResult)
    return __ret__.apply(lambda __response__: GetApprovalWorkflowResult(
        approval_mode=pulumi.get(__response__, 'approval_mode'),
        approval_steps=pulumi.get(__response__, 'approval_steps'),
        approval_workflows=pulumi.get(__response__, 'approval_workflows'),
        description=pulumi.get(__response__, 'description'),
        id=pulumi.get(__response__, 'id'),
        ids=pulumi.get(__response__, 'ids'),
        name=pulumi.get(__response__, 'name')))
