# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetWorkflowResult',
    'AwaitableGetWorkflowResult',
    'get_workflow',
    'get_workflow_output',
]

@pulumi.output_type
class GetWorkflowResult:
    """
    A collection of values returned by getWorkflow.
    """
    def __init__(__self__, access_request_fixed_duration=None, access_request_max_duration=None, approval_flow_id=None, auto_grant=None, description=None, enabled=None, id=None, ids=None, name=None, weight=None, workflows=None):
        if access_request_fixed_duration and not isinstance(access_request_fixed_duration, str):
            raise TypeError("Expected argument 'access_request_fixed_duration' to be a str")
        pulumi.set(__self__, "access_request_fixed_duration", access_request_fixed_duration)
        if access_request_max_duration and not isinstance(access_request_max_duration, str):
            raise TypeError("Expected argument 'access_request_max_duration' to be a str")
        pulumi.set(__self__, "access_request_max_duration", access_request_max_duration)
        if approval_flow_id and not isinstance(approval_flow_id, str):
            raise TypeError("Expected argument 'approval_flow_id' to be a str")
        pulumi.set(__self__, "approval_flow_id", approval_flow_id)
        if auto_grant and not isinstance(auto_grant, bool):
            raise TypeError("Expected argument 'auto_grant' to be a bool")
        pulumi.set(__self__, "auto_grant", auto_grant)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if enabled and not isinstance(enabled, bool):
            raise TypeError("Expected argument 'enabled' to be a bool")
        pulumi.set(__self__, "enabled", enabled)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if weight and not isinstance(weight, int):
            raise TypeError("Expected argument 'weight' to be a int")
        pulumi.set(__self__, "weight", weight)
        if workflows and not isinstance(workflows, list):
            raise TypeError("Expected argument 'workflows' to be a list")
        pulumi.set(__self__, "workflows", workflows)

    @property
    @pulumi.getter(name="accessRequestFixedDuration")
    def access_request_fixed_duration(self) -> Optional[builtins.str]:
        """
        Fixed Duration of access requests bound to this workflow. If fixed duration is provided, max duration must be empty. If neither max nor fixed duration are provided, requests that bind to this workflow will use the organization-level settings.
        """
        return pulumi.get(self, "access_request_fixed_duration")

    @property
    @pulumi.getter(name="accessRequestMaxDuration")
    def access_request_max_duration(self) -> Optional[builtins.str]:
        """
        Maximum Duration of access requests bound to this workflow. If max duration is provided, fixed duration must be empty. If neither max nor fixed duration are provided, requests that bind to this workflow will use the organization-level settings.
        """
        return pulumi.get(self, "access_request_max_duration")

    @property
    @pulumi.getter(name="approvalFlowId")
    def approval_flow_id(self) -> Optional[builtins.str]:
        """
        Optional approval flow ID identifies an approval flow that linked to the workflow
        """
        return pulumi.get(self, "approval_flow_id")

    @property
    @pulumi.getter(name="autoGrant")
    @_utilities.deprecated("""auto_grant is deprecated, see docs for more info""")
    def auto_grant(self) -> Optional[builtins.bool]:
        """
        Optional auto grant setting to automatically approve requests or not, defaults to false.
        """
        return pulumi.get(self, "auto_grant")

    @property
    @pulumi.getter
    def description(self) -> Optional[builtins.str]:
        """
        Optional description of the Workflow.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def enabled(self) -> Optional[builtins.bool]:
        """
        Optional enabled state for workflow. This setting may be overridden by the system if the workflow doesn't meet the requirements to be enabled or if other conditions prevent enabling the workflow. The requirements to enable a workflow are that the workflow must be either set up for with auto grant enabled or have one or more WorkflowApprovers created for the workflow.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        """
        Unique identifier of the Workflow.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ids(self) -> Sequence[builtins.str]:
        """
        a list of strings of ids of data sources that match the given arguments.
        """
        return pulumi.get(self, "ids")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        """
        Unique human-readable name of the Workflow.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def weight(self) -> Optional[builtins.int]:
        """
        Optional weight for workflow to specify it's priority in matching a request.
        """
        return pulumi.get(self, "weight")

    @property
    @pulumi.getter
    def workflows(self) -> Sequence['outputs.GetWorkflowWorkflowResult']:
        """
        A list where each element has the following attributes:
        """
        return pulumi.get(self, "workflows")


class AwaitableGetWorkflowResult(GetWorkflowResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWorkflowResult(
            access_request_fixed_duration=self.access_request_fixed_duration,
            access_request_max_duration=self.access_request_max_duration,
            approval_flow_id=self.approval_flow_id,
            auto_grant=self.auto_grant,
            description=self.description,
            enabled=self.enabled,
            id=self.id,
            ids=self.ids,
            name=self.name,
            weight=self.weight,
            workflows=self.workflows)


def get_workflow(access_request_fixed_duration: Optional[builtins.str] = None,
                 access_request_max_duration: Optional[builtins.str] = None,
                 approval_flow_id: Optional[builtins.str] = None,
                 auto_grant: Optional[builtins.bool] = None,
                 description: Optional[builtins.str] = None,
                 enabled: Optional[builtins.bool] = None,
                 id: Optional[builtins.str] = None,
                 name: Optional[builtins.str] = None,
                 weight: Optional[builtins.int] = None,
                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWorkflowResult:
    """
    Workflows are the collection of rules that define the resources to which access can be requested,
     the users that can request that access, and the mechanism for approving those requests which can either
     but automatic approval or a set of users authorized to approve the requests.


    :param builtins.str access_request_fixed_duration: Fixed Duration of access requests bound to this workflow. If fixed duration is provided, max duration must be empty. If neither max nor fixed duration are provided, requests that bind to this workflow will use the organization-level settings.
    :param builtins.str access_request_max_duration: Maximum Duration of access requests bound to this workflow. If max duration is provided, fixed duration must be empty. If neither max nor fixed duration are provided, requests that bind to this workflow will use the organization-level settings.
    :param builtins.str approval_flow_id: Optional approval flow ID identifies an approval flow that linked to the workflow
    :param builtins.bool auto_grant: Optional auto grant setting to automatically approve requests or not, defaults to false.
    :param builtins.str description: Optional description of the Workflow.
    :param builtins.bool enabled: Optional enabled state for workflow. This setting may be overridden by the system if the workflow doesn't meet the requirements to be enabled or if other conditions prevent enabling the workflow. The requirements to enable a workflow are that the workflow must be either set up for with auto grant enabled or have one or more WorkflowApprovers created for the workflow.
    :param builtins.str id: Unique identifier of the Workflow.
    :param builtins.str name: Unique human-readable name of the Workflow.
    :param builtins.int weight: Optional weight for workflow to specify it's priority in matching a request.
    """
    __args__ = dict()
    __args__['accessRequestFixedDuration'] = access_request_fixed_duration
    __args__['accessRequestMaxDuration'] = access_request_max_duration
    __args__['approvalFlowId'] = approval_flow_id
    __args__['autoGrant'] = auto_grant
    __args__['description'] = description
    __args__['enabled'] = enabled
    __args__['id'] = id
    __args__['name'] = name
    __args__['weight'] = weight
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdm:index/getWorkflow:getWorkflow', __args__, opts=opts, typ=GetWorkflowResult).value

    return AwaitableGetWorkflowResult(
        access_request_fixed_duration=pulumi.get(__ret__, 'access_request_fixed_duration'),
        access_request_max_duration=pulumi.get(__ret__, 'access_request_max_duration'),
        approval_flow_id=pulumi.get(__ret__, 'approval_flow_id'),
        auto_grant=pulumi.get(__ret__, 'auto_grant'),
        description=pulumi.get(__ret__, 'description'),
        enabled=pulumi.get(__ret__, 'enabled'),
        id=pulumi.get(__ret__, 'id'),
        ids=pulumi.get(__ret__, 'ids'),
        name=pulumi.get(__ret__, 'name'),
        weight=pulumi.get(__ret__, 'weight'),
        workflows=pulumi.get(__ret__, 'workflows'))
def get_workflow_output(access_request_fixed_duration: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                        access_request_max_duration: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                        approval_flow_id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                        auto_grant: Optional[pulumi.Input[Optional[builtins.bool]]] = None,
                        description: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                        enabled: Optional[pulumi.Input[Optional[builtins.bool]]] = None,
                        id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                        name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                        weight: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                        opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetWorkflowResult]:
    """
    Workflows are the collection of rules that define the resources to which access can be requested,
     the users that can request that access, and the mechanism for approving those requests which can either
     but automatic approval or a set of users authorized to approve the requests.


    :param builtins.str access_request_fixed_duration: Fixed Duration of access requests bound to this workflow. If fixed duration is provided, max duration must be empty. If neither max nor fixed duration are provided, requests that bind to this workflow will use the organization-level settings.
    :param builtins.str access_request_max_duration: Maximum Duration of access requests bound to this workflow. If max duration is provided, fixed duration must be empty. If neither max nor fixed duration are provided, requests that bind to this workflow will use the organization-level settings.
    :param builtins.str approval_flow_id: Optional approval flow ID identifies an approval flow that linked to the workflow
    :param builtins.bool auto_grant: Optional auto grant setting to automatically approve requests or not, defaults to false.
    :param builtins.str description: Optional description of the Workflow.
    :param builtins.bool enabled: Optional enabled state for workflow. This setting may be overridden by the system if the workflow doesn't meet the requirements to be enabled or if other conditions prevent enabling the workflow. The requirements to enable a workflow are that the workflow must be either set up for with auto grant enabled or have one or more WorkflowApprovers created for the workflow.
    :param builtins.str id: Unique identifier of the Workflow.
    :param builtins.str name: Unique human-readable name of the Workflow.
    :param builtins.int weight: Optional weight for workflow to specify it's priority in matching a request.
    """
    __args__ = dict()
    __args__['accessRequestFixedDuration'] = access_request_fixed_duration
    __args__['accessRequestMaxDuration'] = access_request_max_duration
    __args__['approvalFlowId'] = approval_flow_id
    __args__['autoGrant'] = auto_grant
    __args__['description'] = description
    __args__['enabled'] = enabled
    __args__['id'] = id
    __args__['name'] = name
    __args__['weight'] = weight
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdm:index/getWorkflow:getWorkflow', __args__, opts=opts, typ=GetWorkflowResult)
    return __ret__.apply(lambda __response__: GetWorkflowResult(
        access_request_fixed_duration=pulumi.get(__response__, 'access_request_fixed_duration'),
        access_request_max_duration=pulumi.get(__response__, 'access_request_max_duration'),
        approval_flow_id=pulumi.get(__response__, 'approval_flow_id'),
        auto_grant=pulumi.get(__response__, 'auto_grant'),
        description=pulumi.get(__response__, 'description'),
        enabled=pulumi.get(__response__, 'enabled'),
        id=pulumi.get(__response__, 'id'),
        ids=pulumi.get(__response__, 'ids'),
        name=pulumi.get(__response__, 'name'),
        weight=pulumi.get(__response__, 'weight'),
        workflows=pulumi.get(__response__, 'workflows')))
