# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 api_access_key: Optional[pulumi.Input[builtins.str]] = None,
                 api_secret_key: Optional[pulumi.Input[builtins.str]] = None,
                 host: Optional[pulumi.Input[builtins.str]] = None,
                 retry_rate_limit_errors: Optional[pulumi.Input[builtins.bool]] = None):
        """
        The set of arguments for constructing a Provider resource.
        :param pulumi.Input[builtins.str] api_access_key: A GUID identifying the API key used to authenticate with the StrongDM API.
        :param pulumi.Input[builtins.str] api_secret_key: A base64 encoded secret key used to authenticate with the StrongDM API.
        :param pulumi.Input[builtins.str] host: The host and port of the StrongDM API endpoint.
        :param pulumi.Input[builtins.bool] retry_rate_limit_errors: Whether experienced rate limits should cause the client to sleep instead of erroring out
        """
        if api_access_key is not None:
            pulumi.set(__self__, "api_access_key", api_access_key)
        if api_secret_key is not None:
            pulumi.set(__self__, "api_secret_key", api_secret_key)
        if host is not None:
            pulumi.set(__self__, "host", host)
        if retry_rate_limit_errors is not None:
            pulumi.set(__self__, "retry_rate_limit_errors", retry_rate_limit_errors)

    @property
    @pulumi.getter(name="apiAccessKey")
    def api_access_key(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A GUID identifying the API key used to authenticate with the StrongDM API.
        """
        return pulumi.get(self, "api_access_key")

    @api_access_key.setter
    def api_access_key(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "api_access_key", value)

    @property
    @pulumi.getter(name="apiSecretKey")
    def api_secret_key(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        A base64 encoded secret key used to authenticate with the StrongDM API.
        """
        return pulumi.get(self, "api_secret_key")

    @api_secret_key.setter
    def api_secret_key(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "api_secret_key", value)

    @property
    @pulumi.getter
    def host(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The host and port of the StrongDM API endpoint.
        """
        return pulumi.get(self, "host")

    @host.setter
    def host(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "host", value)

    @property
    @pulumi.getter(name="retryRateLimitErrors")
    def retry_rate_limit_errors(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether experienced rate limits should cause the client to sleep instead of erroring out
        """
        return pulumi.get(self, "retry_rate_limit_errors")

    @retry_rate_limit_errors.setter
    def retry_rate_limit_errors(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "retry_rate_limit_errors", value)


@pulumi.type_token("pulumi:providers:sdm")
class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_access_key: Optional[pulumi.Input[builtins.str]] = None,
                 api_secret_key: Optional[pulumi.Input[builtins.str]] = None,
                 host: Optional[pulumi.Input[builtins.str]] = None,
                 retry_rate_limit_errors: Optional[pulumi.Input[builtins.bool]] = None,
                 __props__=None):
        """
        The provider type for the sdm package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] api_access_key: A GUID identifying the API key used to authenticate with the StrongDM API.
        :param pulumi.Input[builtins.str] api_secret_key: A base64 encoded secret key used to authenticate with the StrongDM API.
        :param pulumi.Input[builtins.str] host: The host and port of the StrongDM API endpoint.
        :param pulumi.Input[builtins.bool] retry_rate_limit_errors: Whether experienced rate limits should cause the client to sleep instead of erroring out
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ProviderArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the sdm package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_access_key: Optional[pulumi.Input[builtins.str]] = None,
                 api_secret_key: Optional[pulumi.Input[builtins.str]] = None,
                 host: Optional[pulumi.Input[builtins.str]] = None,
                 retry_rate_limit_errors: Optional[pulumi.Input[builtins.bool]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            __props__.__dict__["api_access_key"] = api_access_key
            __props__.__dict__["api_secret_key"] = api_secret_key
            __props__.__dict__["host"] = host
            __props__.__dict__["retry_rate_limit_errors"] = pulumi.Output.from_input(retry_rate_limit_errors).apply(pulumi.runtime.to_json) if retry_rate_limit_errors is not None else None
        super(Provider, __self__).__init__(
            'sdm',
            resource_name,
            __props__,
            opts)

    @property
    @pulumi.getter(name="apiAccessKey")
    def api_access_key(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        A GUID identifying the API key used to authenticate with the StrongDM API.
        """
        return pulumi.get(self, "api_access_key")

    @property
    @pulumi.getter(name="apiSecretKey")
    def api_secret_key(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        A base64 encoded secret key used to authenticate with the StrongDM API.
        """
        return pulumi.get(self, "api_secret_key")

    @property
    @pulumi.getter
    def host(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The host and port of the StrongDM API endpoint.
        """
        return pulumi.get(self, "host")

    @pulumi.output_type
    class TerraformConfigResult:
        def __init__(__self__, result=None):
            if result and not isinstance(result, dict):
                raise TypeError("Expected argument 'result' to be a dict")
            pulumi.set(__self__, "result", result)

        @property
        @pulumi.getter
        def result(self) -> Mapping[str, Any]:
            return pulumi.get(self, "result")

    def terraform_config(__self__) -> pulumi.Output['Provider.TerraformConfigResult']:
        """
        This function returns a Terraform config object with terraform-namecased keys,to be used with the Terraform Module Provider.
        """
        __args__ = dict()
        __args__['__self__'] = __self__
        return pulumi.runtime.call('pulumi:providers:sdm/terraformConfig', __args__, res=__self__, typ=Provider.TerraformConfigResult)

